"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getReporter = void 0;
const cspell_types_1 = require("@cspell/cspell-types");
const fs_1 = require("fs");
const mkdirp_1 = __importDefault(require("mkdirp"));
const path = __importStar(require("path"));
const setToJSONReplacer_1 = require("./utils/setToJSONReplacer");
const validateSettings_1 = require("./utils/validateSettings");
const noopReporter = () => undefined;
function getReporter(settings) {
    (0, validateSettings_1.validateSettings)(settings);
    const reportData = {
        issues: [],
        info: [],
        debug: [],
        error: [],
        progress: [],
    };
    return {
        issue: (issue) => {
            reportData.issues.push(issue);
        },
        info: (message, msgType) => {
            if (msgType === cspell_types_1.MessageTypes.Debug && !settings.debug) {
                return;
            }
            if (msgType === cspell_types_1.MessageTypes.Info && !settings.verbose) {
                return;
            }
            reportData.info.push({ message, msgType });
        },
        debug: settings.debug
            ? (message) => {
                reportData.debug.push({ message });
            }
            : noopReporter,
        error: (message, error) => {
            reportData.error.push({ message, error });
        },
        progress: settings.progress
            ? (item) => {
                reportData.progress.push(item);
            }
            : noopReporter,
        result: async (result) => {
            const outFilePath = path.join(process.cwd(), settings.outFile);
            const output = {
                ...reportData,
                result,
            };
            await (0, mkdirp_1.default)(path.dirname(outFilePath));
            return fs_1.promises.writeFile(outFilePath, JSON.stringify(output, setToJSONReplacer_1.setToJSONReplacer, 4));
        },
    };
}
exports.getReporter = getReporter;
//# sourceMappingURL=index.js.map